﻿using System.Collections.Generic;
using System.Linq;
using CommonBehaviors.Actions;
using Singular.Dynamics;
using Singular.Helpers;
using Singular.Managers;
using Singular.Settings;
using Styx;

using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.CommonBot;
using System.Drawing;
using System;

using Action = Styx.TreeSharp.Action;
using Rest = Singular.Helpers.Rest;

namespace Singular.ClassSpecific.DeathKnight
{
    public class Frost
	{
		private static LocalPlayer Me => StyxWoW.Me;
		private static DeathKnightSettings DeathKnightSettings => SingularSettings.Instance.DeathKnight();

	    private const int Rime = 59052;
	    private const int KillingMachine = 51124;
	    private const int DarkSuccor = 101568;
	    private const int Obliteration = 207256;
	    private const int FrostFever = 55095;
	    private const int HungeringRuneWeapon = 207127;

	    #region Normal Rotations

        [Behavior(BehaviorType.Combat, WoWClass.DeathKnight, WoWSpec.DeathKnightFrost)]
        public static Composite CreateDeathKnightFrostCombat()
        {
            return new PrioritySelector(

                Helpers.Common.EnsureReadyToAttackFromMelee(),
                Spell.WaitForCastOrChannel(),
                new PrioritySelector(
                    SingularRoutine.MoveBehaviorInlineToCombat(BehaviorType.Heal),
                    SingularRoutine.MoveBehaviorInlineToCombat(BehaviorType.CombatBuffs),
                    Helpers.Common.CreateInterruptBehavior(),
                    Movement.WaitForFacing(),
                    Movement.WaitForLineOfSpellSight(),
                    Common.CreateDeathKnightPullMore(),
                    Common.CreateDeathGripBehavior(),
                    Common.CreateAntiMagicShellBehavior(),

                    // Cooldowns
                    Spell.BuffSelf("Pillar of Frost", req => Me.GotTarget() && Me.CurrentTarget.IsWithinMeleeRange && Me.CurrentTarget.IsStressful()),
                    Spell.Cast("Horn of Winter", ret => Me.CurrentRunes < 4 && Common.RunicPowerDeficit >= 20),
                    Spell.BuffSelf("Hungering Rune Weapon", ret => Me.CurrentRunes < 2 && Me.CurrentRunicPower < 25),
                    Spell.BuffSelf("Obliteration", ret => !Me.HasAura(KillingMachine) && !Me.HasAura(Rime) && Me.CurrentRunicPower >= 25 && Me.CurrentRunes >= 1 && (Me.HasAura(HungeringRuneWeapon) || Spell.GetSpellCooldown("Hungering Rune Weapon").TotalSeconds >= 89)),
                    Spell.Cast("Death Strike", ret => Me.HasAura(DarkSuccor) && Me.HealthPercent <= 90),
                    Spell.BuffSelf("Icebound Fortitude", ret => Me.HealthPercent <= DeathKnightSettings.IceboundFortitudePercent),

                    Spell.Cast("Howling Blast", ret => Me.CurrentTarget.GetAuraTimeLeft(FrostFever).TotalSeconds < 1.8d),
                    Spell.Cast("Remorseless Winter", ret => Spell.UseAOE && Unit.NearbyUnfriendlyUnits.Count(u => u.IsWithinMeleeRange) >= 2),
                    Spell.Cast("Frostscythe", ret => Spell.UseAOE && Clusters.GetClusterCount(Me.CurrentTarget, Unit.NearbyUnfriendlyUnits, ClusterType.Cone, 8) >= 3),
                    Spell.Cast("Obliterate", ret => Me.HasAura(KillingMachine)),
                    Spell.Cast("Howling Blast", ret => Me.HasAura(Rime)),
                    Spell.Cast("Obliterate", ret => Me.CurrentRunicPower <= 60),
                    Spell.Cast("Frost Strike")
                ),

                Movement.CreateMoveToMeleeBehavior(true)
            );
        }

		#endregion
	}
}